function [fval, x] = getMRC_IP_superpixel(wN, wD, A1, A2,C1,C2,B1, B2,  xF, xB, numOfCycles);
%[fval, x] = getMCC_LP_superpixel(N, A1, A2,C1,C2, B1, B2, xF, xB, numOfCycles);

% get minimum curvature contour cloure

    numOfNodes = size(A1,1);
    numOfEdges = size(C1,1);
    numOfFaces = size(C1,2);

    lb = zeros(numOfFaces+numOfEdges+numOfEdges+numOfNodes,1);
    ub = ones(numOfFaces+numOfEdges+numOfEdges+numOfNodes,1);

  
    % Initialize the CPLEX object
    cplex = Cplex('bilp');
       
    
     % Fill in the data for the problem using populate by row
    cplex.Model.sense = 'minimize';

    
     % type constraint
     xType = ones([1 numOfFaces])*('B');
     yType = ones([1 numOfEdges])*('B');
     ybType = ones([1 numOfEdges])*('B');
     zType = ones([1 numOfNodes])*('B');
    ctype = char([xType yType ybType zType]);
    N=[zeros(numOfFaces,1); zeros(numOfEdges,1); wN; zeros(numOfNodes,1)];
    D=[zeros(numOfFaces,1); zeros(numOfEdges,1); wD; zeros(numOfNodes,1)];
    
    [f0, x0] = getMCC_IP_superpixel(wN, A1, A2, C1, C2,B1, B2, xF, xB, numOfCycles);
    tL = 0;
    tU = (N' * x0) /(D' * x0);
    t0 = (tU+tL)/2;
    f  = N - t0 .* D;
    
    cplex.addCols(f, [], lb, ub, ctype);
    %cplex.addCols(f, [], lb, ub);
 
    %% inside/outside constraints    
    
    cplex.addRows(xF,[eye(numOfFaces) zeros(numOfFaces,numOfEdges+numOfEdges+numOfNodes)],1-xB);
    
    % y=(yb+C2*x)/2
    cplex.addRows(zeros(numOfEdges,1), ...
        [C2/2 -eye(numOfEdges,numOfEdges) eye(numOfEdges,numOfEdges)/2 zeros(numOfEdges,numOfNodes)],...
        zeros(numOfEdges,1));

    % cosntraint z
    cplex.addRows(ones(numOfNodes,1)*(-inf), ...
        [zeros(numOfNodes,numOfFaces) A1 zeros(numOfNodes,numOfEdges) -eye(numOfNodes,numOfNodes) ],...
        zeros(numOfNodes,1));
    cplex.addRows(zeros(numOfNodes,1), ...
        [zeros(numOfNodes,numOfFaces) A2 zeros(numOfNodes,numOfEdges) -eye(numOfNodes,numOfNodes) ],...
        ones(numOfNodes,1)*inf);

    
    % Constraint on euler formula 
    
    cplex.addRows(numOfCycles, ...
        [ones(1,numOfFaces) -ones(1,numOfEdges) zeros(1,numOfEdges) ones(1,numOfNodes)],...
        numOfCycles);

%    cplex.addRows(-inf, ...
 %       [ones(1,numOfFaces) -ones(1,numOfEdges) zeros(1,numOfEdges) ones(1,numOfNodes)],...
  %      numOfCycles);

    
    %% y=|C1*x|
    cplex.addRows(zeros(numOfEdges,1), ...
        [-C1 zeros(numOfEdges,numOfEdges) eye(numOfEdges,numOfEdges) zeros(numOfEdges,numOfNodes)],...
        ones(numOfEdges,1)*inf);
    cplex.addRows(zeros(numOfEdges,1), ...
        [C1 zeros(numOfEdges,numOfEdges)  eye(numOfEdges,numOfEdges) zeros(numOfEdges,numOfNodes)],...
        ones(numOfEdges,1)*inf);
    
    
      %% Trick: sum(X(1:numOffaces)>=numF)
       
%      cplex.addRows(numF, [ones(1,numOfFaces) zeros(1,numOfEdges+numOfEdges+numOfNodes)], inf);
%     
    
    %% y<=C2*x
   % cplex.addRows(ones(numOfEdges,1)*(-2), [-C2 eye(numOfEdges,numOfEdges) zeros(numOfEdges,numOfNodes)],zeros(numOfEdges,1));

    %% y<=B1*y;

   cplex.addRows(ones(numOfEdges,1)*(-inf), [zeros(numOfEdges,numOfFaces) zeros(numOfEdges,numOfEdges) eye(numOfEdges,numOfEdges)-B1 zeros(numOfEdges,numOfNodes)],zeros(numOfEdges,1));
   
   %% y<=B2*y;
   
   cplex.addRows(ones(numOfEdges,1)*(-inf), [zeros(numOfEdges,numOfFaces) zeros(numOfEdges,numOfEdges) eye(numOfEdges,numOfEdges)-B2  zeros(numOfEdges,numOfNodes)],zeros(numOfEdges,1));
   


%% Initialize
    maxIter = 1e4;
    tol = 1e-6;
    
    for i=1:maxIter
        t0 = (tU+tL)/2;
        f     = N - t0 .* D;      
        cplex.Model.obj = f;
        try
            % Optimize the problem
            cplex.solve();
        catch m
            disp(m.message);
        end       

        if cplex.Solution.status == 103
            disp('No solution from cplexbilp!');  

            cplex.Solution.status    
            cplex.Solution.statusstring

            fval = 0;
            x=[];
            break;
        else
          
          fval = cplex.Solution.objval;
          x = cplex.Solution.x;

           if fval==0
               disp('Solution found: fval==0');
                break;
           elseif fval<0
                tU = (N' * x) /(D' * x);            
           else
                tL = t0;
           end
        
        end
        
        if abs(tU-tL)<tol %|| (tU+tL)/2==t0
            
            disp('Solution found: abs(tU-tL)<tol');
            
            break;
        end
    
    end
    
       if(numel(x)>0)
          disp('Solution found: ');
          
          numIteration = i
       
          fval = t0
         % find(x) 
          numF =  ones(1,numOfFaces) * x(1:numOfFaces)
          numE = ones(1,numOfEdges) * x(numOfFaces+1:numOfEdges+numOfFaces)
          numV = ones(1,numOfNodes)* x(2*numOfEdges+numOfFaces+1:end)
          euler = numF+numV-numE
        end

    
   % x = x>=0.5;
    
    function printSolution
        fprintf('\nSolution status = %s \n',cplex.Solution.statusstring);
        fprintf('Solution value = %f \n',cplex.Solution.objval);
        disp('Values =');
        disp(cplex.Solution.x);
        disp('Slacks =');
        disp(cplex.Model.rhs-cplex.Solution.ax);
    end

    function printViriables
            
        face0
        edge0 
        nodes0=A*edge0
        oldedges0=S*edge0
        lambda1
        lambda2
    end
    
end

